package de.dhsn.oop.data;

import com.google.gson.Gson;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class TodoList {
    List<TextTodoItem> list;
    String listTitle;

    public TodoList(String listTitle) {
        this.listTitle = listTitle;
        this.list = new ArrayList<>();
    }

    public String getListTitle() {
        return listTitle;
    }

    public void setListTitle(String listTitle) {
        this.listTitle = listTitle;
    }

    public void addTodo(TextTodoItem item){
        list.add(item);
    }

    public List<TextTodoItem> getList(){
        Collections.sort(list, new Comparator<TextTodoItem>() {
            @Override
            public int compare(TextTodoItem o1, TextTodoItem o2) {
                return Boolean.compare(o1.isDone(), o2.isDone());
            }
        });
        return list;
    }

    public int length(){
        return list.size();
    }

    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
