package de.dhsn.oop.ui;

import de.dhsn.oop.data.TodoList;
import de.dhsn.oop.ui.UIOverrides.FlatLabel;
import de.dhsn.oop.ui.UIOverrides.FlatPanel;

import javax.swing.*;
import java.awt.*;

/**
 * Overview List Item to show Todo Lists on the home screen
 */
public class ListOverviewItem extends FlatPanel {
    private FlatLabel titleText = new FlatLabel();
    private FlatLabel title = new FlatLabel();
    private FlatLabel length = new FlatLabel();
    private FlatLabel lenghtText = new FlatLabel();

    public ListOverviewItem(TodoList list) {
        this.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 0;

        c.insets = new Insets(2,2,2,2);

        title.setText(list.getListTitle());
        title.setFont(title.getFont().deriveFont(Font.BOLD, 15f));
        titleText.setText("Titel: ");
        lenghtText.setText("Anz.: ");
        length.setText(Integer.toString(list.length()));

        this.add(titleText, c);
        c.gridx++;

        this.add(title, c);
        c.gridx++;

        this.add(lenghtText, c);
        c.gridx++;

        this.add(length, c);

        this.setVisible(true);
    }
}
