package de.dhsn.oop.ui;

import de.dhsn.oop.data.TextTodoItem;
import de.dhsn.oop.ui.UIOverrides.FlatButton;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * This class will present a for with a input field for the name of a new TodoItem to create
 */
public class NewTodoItemView extends JFrame implements ActionListener {
    JTextField input = new JTextField();
    FlatButton submit = new FlatButton("OK");
    TodoListView view;

    /**
     * Constructor to initialize the new todoitem window
     * the calling class, TodoListView has to be passed to allow for a callback on save
     * @param view TodoListView instance to call the callback on
     */
    public NewTodoItemView(TodoListView view){
        this.view = view;
        this.setMaximumSize(new Dimension(200,70));
        this.setSize(new Dimension(200,70));
        setLayout(new BorderLayout());
        add(new Label("Text: "), BorderLayout.LINE_START);
        add(input, BorderLayout.CENTER);
        submit.addActionListener(this);
        add(submit, BorderLayout.LINE_END);
        setVisible(true);
    }

    /**
     * this function gets called when the OK button gets clicked
     * it will take the text from the input, create a new todoitem and pass it to the TodoListView passed to the constructor
     * @param e the event to be processed
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        //hand data back to parent windwo
        view.addCallback(new TextTodoItem(input.getText().trim()));
        //close and remove this window
        setVisible(false);
        dispose();
    }
}
