package de.dhsn.oop.ui;

import de.dhsn.oop.data.TodoItem;
import de.dhsn.oop.data.TodoList;
import de.dhsn.oop.ui.UIOverrides.FlatButton;
import de.dhsn.oop.ui.UIOverrides.FlatCheckBox;
import de.dhsn.oop.ui.UIOverrides.FlatLabel;
import de.dhsn.oop.ui.UIOverrides.FlatPanel;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class TodoItemPanel extends FlatPanel implements ActionListener {
    private TodoItem item;
    private TodoList list;
    private TodoListView view;

    public TodoItemPanel(TodoItem i, TodoList l, TodoListView v){
        item = i;
        list = l;
        view = v;
        setLayout(new BorderLayout());

        FlatCheckBox cb = new FlatCheckBox();
        cb.setSelected(item.isDone());
        cb.addActionListener(this);
        add(cb, BorderLayout.LINE_START);

        FlatLabel title = new FlatLabel(item.title);
        add(title, BorderLayout.CENTER);

        FlatButton delete = new FlatButton("X");
        delete.addActionListener(this::deletePressed);
        add(delete, BorderLayout.LINE_END);

        setVisible(true);
    }

    /**
     * checkbox action listener for done state of item
     * @param e the event to be processed
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        item.setDone(((FlatCheckBox)(e.getSource())).isSelected());
    }

    /**
     * delete item button callback function
     * the current item has to be rmeoved from the list
     * @param e
     */
    public void deletePressed(ActionEvent e) {
        list.getList().remove(item);
        view.forceRerender();
    }
}
